//  ModelTest.java


import java.util.*;
import java.lang.reflect.*;

import resources.ModelTestHelper;
import com.rational.test.ft.*;
import com.rational.test.ft.object.interfaces.*;
import com.rational.test.ft.script.*;
import com.rational.test.ft.value.*;
import com.rational.test.ft.vp.*;



public class ModelTest extends ModelTestHelper 
{
	State[] m_states;
   	VerifyPage m_VerifyPage;
	int curState = States.HOME;
	
	int navType;
	NavLogReader s1;
 
   	private void initalizeStates() {
      m_states = new State[States.NUM_STATES];
      for (int i=0;i<m_states.length;i++){
         //create the states
         m_states[i] = new State(i);
      }
   
      // Give each state a name for easy debugging
      m_states[States.HOME].m_stateName = "Home";
      m_states[States.YELLOW_PAGES].m_stateName = "Yellow Pages";
      m_states[States.NEWS].m_stateName = "News";
      m_states[States.AUCTION].m_stateName = "Auction";
      m_states[States.MAIL].m_stateName = "Mail";
      m_states[States.IMAGES].m_stateName = "Images";
      m_states[States.NEWS_HEADLINE_1].m_stateName = "News Headline 1";
      m_states[States.NEWS_HEADLINE_2].m_stateName = "News Headline 2";
      m_states[States.NEWS_HEADLINE_3].m_stateName = "News Headline 3";
      
       // Initialize the verification methods
      m_VerifyPage = new VerifyPage();
      m_states[States.HOME].VerifyMethod = "VerifyHome";
      m_states[States.NEWS].VerifyMethod = "VerifyNews";
      m_states[States.MAIL].VerifyMethod = "VerifyMail";
      m_states[States.YELLOW_PAGES].VerifyMethod = "VerifyYellowPages";
        
 
       // Now initialize the Transitions
      
      // Initialize all transitions from the HOME state   
      m_states[States.HOME].m_transitions.add(
      				new transition (ButtonHome(),m_states[States.HOME])); 
      m_states[States.HOME].m_transitions.add(
      				new transition (ButtonImages(),m_states[States.IMAGES])); 
      m_states[States.HOME].m_transitions.add(
      				new transition (ButtonYellowPages(),m_states[States.YELLOW_PAGES])); 
      m_states[States.HOME].m_transitions.add(
      				new transition (ButtonNews(),m_states[States.NEWS])); 
      m_states[States.HOME].m_transitions.add(
      				new transition (ButtonAuction(),m_states[States.AUCTION])); 
      m_states[States.HOME].m_transitions.add(
      				new transition (ButtonMail(),m_states[States.MAIL])); 

      m_states[States.IMAGES].m_transitions.add(
      				new transition (ButtonHome(),m_states[States.HOME])); 
      m_states[States.IMAGES].m_transitions.add(
      				new transition (ButtonImages(),m_states[States.IMAGES])); 
      m_states[States.IMAGES].m_transitions.add(
      				new transition (ButtonYellowPages(),m_states[States.YELLOW_PAGES])); 
      m_states[States.IMAGES].m_transitions.add(
      				new transition (ButtonNews(),m_states[States.NEWS])); 
      m_states[States.IMAGES].m_transitions.add(
      				new transition (ButtonAuction(),m_states[States.AUCTION])); 
      m_states[States.IMAGES].m_transitions.add(
      				new transition (ButtonMail(),m_states[States.MAIL])); 

      m_states[States.YELLOW_PAGES].m_transitions.add(
      				new transition (ButtonHome(),m_states[States.HOME])); 
      m_states[States.YELLOW_PAGES].m_transitions.add(
      				new transition (ButtonImages(),m_states[States.IMAGES])); 
      m_states[States.YELLOW_PAGES].m_transitions.add(
      				new transition (ButtonYellowPages(),m_states[States.YELLOW_PAGES])); 
      m_states[States.YELLOW_PAGES].m_transitions.add(
      				new transition (ButtonNews(),m_states[States.NEWS])); 
      m_states[States.YELLOW_PAGES].m_transitions.add(
      				new transition (ButtonAuction(),m_states[States.AUCTION])); 
      m_states[States.YELLOW_PAGES].m_transitions.add(
      				new transition (ButtonMail(),m_states[States.MAIL])); 

      m_states[States.NEWS].m_transitions.add(
      				new transition (ButtonHome(),m_states[States.HOME])); 
      m_states[States.NEWS].m_transitions.add(
      				new transition (ButtonImages(),m_states[States.IMAGES])); 
      m_states[States.NEWS].m_transitions.add(
      				new transition (ButtonYellowPages(),m_states[States.YELLOW_PAGES])); 
      m_states[States.NEWS].m_transitions.add(
      				new transition (ButtonNews(),m_states[States.NEWS])); 
      m_states[States.NEWS].m_transitions.add(
      				new transition (ButtonAuction(),m_states[States.AUCTION])); 
      m_states[States.NEWS].m_transitions.add(
      				new transition (ButtonMail(),m_states[States.MAIL])); 
      m_states[States.NEWS].m_transitions.add(
      				new transition (Link_BarneyRubbleWinsTheTourDe(),m_states[States.NEWS_HEADLINE_1])); 
      m_states[States.NEWS].m_transitions.add(
      				new transition (Link_MammothMountainannouncesF(),m_states[States.NEWS_HEADLINE_2])); 
      m_states[States.NEWS].m_transitions.add(
      				new transition (Link_NASCARoffersbicycleracers(),m_states[States.NEWS_HEADLINE_3])); 
	
	  // News articles States      				
      m_states[States.NEWS_HEADLINE_1].m_transitions.add(
      				new transition (BrowserToolbar_Back(),m_states[States.NEWS])); 

      m_states[States.NEWS_HEADLINE_2].m_transitions.add(
      				new transition (BrowserToolbar_Back(),m_states[States.NEWS])); 
      m_states[States.NEWS_HEADLINE_2].m_transitions.add(
				    new transition (ButtonHome(),m_states[States.NEWS])); 
      				
      m_states[States.NEWS_HEADLINE_3].m_transitions.add(
      				new transition (BrowserToolbar_Back(),m_states[States.NEWS])); 
      m_states[States.NEWS_HEADLINE_3].m_transitions.add(
				    new transition (ButtonHome(),m_states[States.NEWS])); 
     				

      m_states[States.AUCTION].m_transitions.add(
      				new transition (ButtonHome(),m_states[States.HOME])); 
      m_states[States.AUCTION].m_transitions.add(
      				new transition (ButtonImages(),m_states[States.IMAGES])); 
      m_states[States.AUCTION].m_transitions.add(
      				new transition (ButtonYellowPages(),m_states[States.YELLOW_PAGES])); 
      m_states[States.AUCTION].m_transitions.add(
      				new transition (ButtonNews(),m_states[States.NEWS])); 
      m_states[States.AUCTION].m_transitions.add(
      				new transition (ButtonAuction(),m_states[States.AUCTION])); 
      m_states[States.AUCTION].m_transitions.add(
      				new transition (ButtonMail(),m_states[States.MAIL])); 

      m_states[States.MAIL].m_transitions.add(
      				new transition (ButtonHome(),m_states[States.HOME])); 
      m_states[States.MAIL].m_transitions.add(
      				new transition (ButtonImages(),m_states[States.IMAGES])); 
      m_states[States.MAIL].m_transitions.add(
      				new transition (ButtonYellowPages(),m_states[States.YELLOW_PAGES])); 
      m_states[States.MAIL].m_transitions.add(
      				new transition (ButtonNews(),m_states[States.NEWS])); 
      m_states[States.MAIL].m_transitions.add(
      				new transition (ButtonAuction(),m_states[States.AUCTION])); 
      m_states[States.MAIL].m_transitions.add(
      				new transition (ButtonMail(),m_states[States.MAIL])); 


   }
 
  
	public interface States 
	{
		int
            HOME = 0,
            IMAGES = 1,
            YELLOW_PAGES = 2,
            NEWS = 3,
            AUCTION = 4,
            MAIL = 5,
            NEWS_HEADLINE_1 = 6,
            NEWS_HEADLINE_2 = 7,
            NEWS_HEADLINE_3 = 8,
            
            NUM_STATES = 9;
	}

	class State
	{
		public int m_state;
	    public transitionList m_transitions;
		public String m_stateName;
		public boolean bVisited;
		public int distToDest;
		public int transitionToDest;
		// Method VerifyMethod;
		String VerifyMethod;
	    State(int s)
	    {
	    	bVisited = false;
	    	m_state = s;	
	    	m_transitions = new transitionList();
	    }  
	}
	
	public class transition
	{
		public GuiTestObject m_trigger;
	    public State m_destination;   
	    public transition(GuiTestObject o, State s){
	        m_trigger = o; m_destination = s;
	    }

	}
	public class transitionList
	{  
		private java.util.List list = new ArrayList();

  		public void add(transition m) { list.add(m); }
  		public transition get(int index) {
    		return (transition)list.get(index);
  		}
  		public int size() { return list.size(); }

	}
	
	
	public class VerifyPage
	{
		public void VerifyHome()
		{
			HomePageTextVP().performTest();
		}
		public void VerifyNews()
		{
			NewsHeadLineTitleVP().performTest();
			NewsHeadLine1VP().performTest();
		}
		public void VerifyMail()
		{
			MailTopRowVP().performTest();
		}
		public void VerifyYellowPages()
		{
	        // HTML Browser
	        TextInputSearchYellow().click(atPoint(16,10));
	        Browser_htmlBrowser(Document_ModelTestDemo(),DEFAULT_FLAGS).inputChars("Breitling Watch");
	        Button_JeffooSearchsubmit().click();
	        BrowserToolbar_Back().click();
		}
	}

	public void clickit(GuiTestObject currGuiObject,int x, int y)
	{
		currGuiObject.click(atPoint(x,y));
	}
	

	private boolean FillDestInfo(int destState, int curDist)
	{
		boolean transitionFound = false;
		// For each state 
		for (int i=0;i<m_states.length;i++)
	  	{
	  		// look through each transition that points to the destination
			for (int j=0; j < m_states[i].m_transitions.size();j++)
			{
				if (m_states[i].m_transitions.get(j).m_destination.m_state == destState)
				{ 
					// We found a pointer to the destination state that has no distance so far
					// so fill it
					m_states[i].distToDest = curDist;
					m_states[i].transitionToDest = j;
					transitionFound = true; // at least one transition found
					break;
				}
			}
	  	}
	  	return transitionFound;		
	}
	
	private boolean FindPathToDest (int srcState, int destState)
	{
		if (FillDestInfo(destState,1) == false)
			return false;
		// 20 is an arbitrary depth 
		for (int curDist = 1; curDist < 20; curDist++)
		{
			for (int i=0;i<m_states.length;i++)
		  	{
		  		if (m_states[i].distToDest == curDist)
		  			FillDestInfo(i,curDist+1);
		  		if (srcState == i)
		  		{
		  			return true;
		  		}
		  	}
		}
		return false;
	}
	
	public void PerformTransition(int transitionIdx)
	{
		m_states[curState].m_transitions.get(transitionIdx).m_trigger.click();
		curState = m_states[curState].m_transitions.get(transitionIdx).m_destination.m_state;
		PerformVerification();
	}
	public void PerformVerification()
	{
		Method VerifyMethod;
		
		logInfo("State: " +  m_states[curState].m_stateName);
		m_states[curState].bVisited = true;
		// If there is a verify method for this state, call it
		if (m_states[curState].VerifyMethod != null)
		{
 			logInfo("Verify: " +  m_states[curState].m_stateName);
			try {
	
				VerifyMethod = m_VerifyPage.getClass().getMethod(m_states[curState].VerifyMethod,null);		
				VerifyMethod.invoke(m_VerifyPage,null);
			}
			catch
				(Throwable e) {
					System.err.println(m_states[curState].m_stateName + e);
				}
	 	}
	}
	public void testMain (Object[] args) 
	{
		int nextState;
		int curTransition;
		Random stateRand = new Random();
		Method VerifyMethod;
		NavLogWriter navLog = null;
		 
		initalizeStates();
     
     	// Close All the browsers
     
		IWindow[] wins = getTopWindows();
		for (int n = 0; n < wins.length; ++n) 
		{
			if (wins[n].getWindowClassName().equals("IEFrame")) 
			{
				wins[n].close();
			}
		}
		
		// Set this value to the URL for your application.
		// Remember to configure the application for testing using
		// the Configure->Configure Applications For Testing menu item above
	  	startApp("http://www.sherpas.com/mbt/index.html");

 		long start, end;
 		
 		// Set Navigation algorithm here. Only set one. The other two should
 		// remained commented out.
 		navType = NavTypes.RANDOM;
 		// navType = navTypes.ALLPATHS;
 		// navType = NavTypes.PLAYLOG;

  		
 		// These values determine the duration of the test. Set all three values.
 		// For example: days = 1, minutes = 2, seconds = 3
 		//      will run the test for 1 day 2 minutes and 3 seconds.	
 		int days = 0;
 		int minutes = 0;
 		int seconds = 30;

 		start = System.currentTimeMillis();
 		end = start + (seconds * 1000) + (minutes * 60000) + (days * 24* (60 * 60000));
 		java.util.Date startDate = new java.util.Date (start);
 		java.util.Date endDate = new java.util.Date (end);
		logInfo("Start: " + startDate.toString());
		logInfo("End:   " + endDate.toString());
		
		if (navType == NavTypes.PLAYLOG)
		{
			NavLogReader s1 = new NavLogReader(this);
			s1.parseURI("log.xml");
		}

		else
		{
		  	navLog = new NavLogWriter(navType);

			while (System.currentTimeMillis() <= end)
			{
				curTransition = -1;
				logInfo("State: " +  m_states[curState].m_stateName);
				// mark state as visited
				m_states[curState].bVisited = true;
				// If there is a verify method for this state, call it
				if (m_states[curState].VerifyMethod != null)
				{
		 			logInfo("Verify: " +  m_states[curState].m_stateName);
					try {
			
						VerifyMethod = m_VerifyPage.getClass().getMethod(m_states[curState].VerifyMethod,null);		
						VerifyMethod.invoke(m_VerifyPage,null);
					}
					catch
						(Throwable e) {
							System.err.println(m_states[curState].m_stateName + e);
						}
			 	}
			 	switch (navType )
			 	{
			 		case NavTypes.RANDOM:
					 	// Random Navigation
						// logInfo("Random Bound: " + m_states[curState].m_transitions.size());
						curTransition = stateRand.nextInt(m_states[curState].m_transitions.size());
						m_states[curState].m_transitions.get(curTransition).m_trigger.click();
						curState = m_states[curState].m_transitions.get(curTransition).m_destination.m_state;
						break;
						
					case NavTypes.ALLPATHS:
						boolean bFoundATransition = false;
						// Find the first transition that takes us to an un-visited state
						for (int i = 0; i < m_states[curState].m_transitions.size(); i++)
						{
							nextState = m_states[curState].m_transitions.get(i).m_destination.m_state;
							if (m_states[nextState].bVisited == false)
							{
								// We found a un-visited state. Let's go
								bFoundATransition = true;
								m_states[curState].m_transitions.get(i).m_trigger.click();
								curState = m_states[curState].m_transitions.get(i).m_destination.m_state;
								curTransition = i;
								break;
							}
						}
						if (!bFoundATransition)
						{
							// Still haven't found a transition. So we need to search through
							// all the states to find an unvisited state. Then we will figure
							// out a path to that state.
							logInfo("Begin Compute Path");
							nextState = -1;
							for (int i=0;i<m_states.length;i++)
							{
								if(!m_states[i].bVisited)
							 	{
							 		nextState = i;
							 		break;
							 	}
							}
							if (nextState != -1)
							{
						 		// Now compute the path to that state;
						 		if (FindPathToDest(curState,nextState))
						 		{
						 			// OK found a path so traverse from src to dest
						 			logInfo("Traversing to: " + m_states[nextState].m_stateName);
						 			// Now go to that state 
						 			for (int j=m_states[curState].distToDest; j>0; j--)
									{
									 	m_states[curState].m_transitions.get(m_states[curState].transitionToDest).m_trigger.click();
									   	curState = m_states[curState].m_transitions.get(m_states[curState].transitionToDest).m_destination.m_state;								    	 
									   	curTransition = m_states[curState].transitionToDest;
						 			}
						 			// Clean Up this traverse
									for (int i=0;i<m_states.length;i++)
						 			{
						 				m_states[i].distToDest = 0;
						 				m_states[i].transitionToDest = 0;
						 			}
						 		}
						 		else
						 		{
						 			logInfo("No Path to: " + m_states[nextState].m_stateName + " from: " +
						 			m_states[curState].m_stateName);						 			
						 		}
							}
							else
							{
								logInfo("All States Traversed");
								// clean-up visited list and start again
								for (int i=0;i< m_states.length;i++)
									m_states[i].bVisited = false;
							}
						}
						break;
						
				}
				if (curTransition != -1)
				{
					navLog.logChange(navType,curTransition);
				}
			}
			navLog.closeLog(navType);
		}
        // HTML Browser
        Browser_htmlBrowser(Document_ModelTestDemo(),MAY_EXIT).close();      
	}
}