//  NavLogWriter.java
//  (c) Jeffrey Feldstein 2004
//  www.sherpas.com. See copyright notice in Copyright.txt.

import java.io.*;
import java.nio.*;
import java.nio.channels.*;


public class NavLogWriter 
{
	private FileChannel fc;
    NavLogWriter(int navType) 
	{
		if (navType != NavTypes.PLAYLOG)
		{
			try {
				fc = new FileOutputStream("log.xml").getChannel();
	    	 	fc.write(ByteBuffer.wrap("<?xml version=\"1.0\" ?>\n".getBytes()));
			 	fc.write(ByteBuffer.wrap("<NavigationLog>\n".getBytes()));
			}
			catch (Throwable e) {
			    System.err.println("Can't Open navigation log.");
			}
		}
	}
	
	void logChange(int navType, int transition) 
	{
		if (navType != NavTypes.PLAYLOG)
		{
			try {
	
				fc.write(ByteBuffer.wrap("<changeState>".getBytes()));
				String line = "<transition>" + transition + "</transition>\n</changeState>\n";
				fc.write(ByteBuffer.wrap(line.getBytes()));
			}
			catch (Throwable e) {
			    System.err.println("Can't Open navigation log.");
			}
		}
			
    //fc.write(ByteBuffer.wrap("<destState>HOME</destState>".getBytes()));
    //fc.write(ByteBuffer.wrap("</changeState>".getBytes()));
	}
	void closeLog(int navType) 
	{
		if (navType != NavTypes.PLAYLOG)
		{
			try {
		 			fc.write(ByteBuffer.wrap("</NavigationLog>\n".getBytes()));
					fc.close();
			}
			catch (Throwable e) {
			    System.err.println("Can't Close navigation log.");
			}
		}
	}
  //  saxReader s1 = new saxReader();
   // s1.parseURI("log.xml");
}